# Generated by go2rpm 1.3
%bcond_without check

# https://github.com/google/go-containerregistry
%global goipath         github.com/google/go-containerregistry
Version:                0.5.1

%gometa

%global common_description %{expand:
Go library and CLIs for working with container registries.}

%global golicenses      LICENSE
%global godocs          README.md CONTRIBUTING.md

Name:           %{goname}
Release:        8%{?dist}
Summary:        Go library and CLIs for working with container registries

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}

BuildRequires:  golang(github.com/containerd/stargz-snapshotter/estargz)
BuildRequires:  golang(github.com/docker/cli/cli/config)
BuildRequires:  golang(github.com/docker/cli/cli/config/types)
BuildRequires:  golang(github.com/docker/distribution/registry/client/auth/challenge)
BuildRequires:  golang(github.com/docker/docker/api/types)
BuildRequires:  golang(github.com/docker/docker/client)
BuildRequires:  golang(github.com/google/go-cmp/cmp)
BuildRequires:  golang(github.com/opencontainers/image-spec/specs-go/v1)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/cobra/doc)
BuildRequires:  golang(k8s.io/kubernetes/pkg/credentialprovider)
BuildRequires:  golang(k8s.io/kubernetes/pkg/credentialprovider/aws)
BuildRequires:  golang(k8s.io/kubernetes/pkg/credentialprovider/azure)
BuildRequires:  golang(k8s.io/kubernetes/pkg/credentialprovider/gcp)
BuildRequires:  golang(k8s.io/kubernetes/pkg/credentialprovider/secrets)
BuildRequires:  golang(golang.org/x/oauth2)
BuildRequires:  golang(golang.org/x/oauth2/google)
BuildRequires:  golang(golang.org/x/sync/errgroup)
BuildRequires:  golang(k8s.io/api/core/v1)
BuildRequires:  golang(k8s.io/apimachinery/pkg/apis/meta/v1)
BuildRequires:  golang(k8s.io/client-go/kubernetes)
BuildRequires:  golang(k8s.io/client-go/rest)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/google/go-cmp/cmp/cmpopts)
BuildRequires:  golang(k8s.io/client-go/kubernetes/fake)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
sed -i "s|github.com/vdemeester/k8s-pkg-credentialprovider|k8s.io/kubernetes/pkg/credentialprovider|" $(find . -iname "*.go" -type f)

%build
for cmd in cmd/* ; do
  if [ $(basename $cmd) = "registry" ]; then
    # Binary "registry" already exists in Fedora; renaming to containerregistry
    %gobuild -o %{gobuilddir}/bin/containerregistry %{goipath}/$cmd
  elif [ $(basename $cmd) != "ko" ]; then
    # cmd/ko contains no go code
    %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
  fi
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
# Exclude unit tests in pkg/v1/google because they require gcloud installed
# Exclude unit tests in pkg/v1/tarball because they require network
%gocheck -d pkg/v1/google -d pkg/v1/tarball
%endif

%files
%license LICENSE
%doc README.md CONTRIBUTING.md cmd/crane/README.md cmd/crane/doc
%{_bindir}/*

%gopkgfiles

%changelog
* Wed Aug 10 2022 Maxwell G <gotmax@e.email> - 0.5.1-8
- Rebuild to fix FTBFS

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 19 2022 Maxwell G <gotmax@e.email> - 0.5.1-6
- Rebuild for CVE-2022-{1705,32148,30631,30633,28131,30635,30632,30630,1962} in
  golang

* Sat Jun 18 2022 Robert-André Mauchin <zebob.m@gmail.com> - 0.5.1-5
- Rebuilt for CVE-2022-1996, CVE-2022-24675, CVE-2022-28327, CVE-2022-27191,
  CVE-2022-29526, CVE-2022-30629

* Sat Apr 16 2022 Fabio Alessandro Locati <me@fale.io> - 0.5.1-4
- Rebuilt for CVE-2022-27191

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jul 16 12:59:56 CEST 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.5.1-1
- Update to latest upstream 0.5.1 - Fixes rhbz#1963660

* Tue Mar 16 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.4.1-1
- Update to latest upstream 0.4.1

* Wed Jan 27 22:24:20 CET 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.4.0-1
- Initial package

